import { ElementRef, Renderer2, OnDestroy, EventEmitter, OnInit } from '@angular/core';
import { HighlightService } from './highlight.service';
import { HighlightResult } from './highlight.model';
/** There are 2 ways to higlight a code
 *  1 - using the [code] input (default) <code highlight [code]="yourCode"></code>
 *  2 - using element text content <code> {{yourCode}} </code>
 */
export declare class HighlightDirective implements OnInit, OnDestroy {
    private renderer;
    private hl;
    el: HTMLElement;
    domObs: MutationObserver;
    code: string;
    highlight: string;
    language: string[];
    setCode: string;
    highlighted: EventEmitter<HighlightResult>;
    constructor(el: ElementRef, renderer: Renderer2, hl: HighlightService);
    ngOnInit(): void;
    /** Highlight using element text content */
    highlightTextContent(): void;
    /** Highlight a code block */
    highlightElement(el: HTMLElement, code: string): void;
    /** Highlight multiple code blocks */
    highlightChildren(el: HTMLElement, selector: string): void;
    ngOnDestroy(): void;
}
